# fails with zillions of internal linking issues if these are used;
# doesn't build any shared libraries anyway, only modules - AdamW
# 2008/07
%define _disable_ld_no_undefined 1
%define _disable_ld_as_needed 1

%define shortname	xgl
%define name		x11-server-xgl
%define version		0.0.1
%define rel		3
%define git		20080722

%if %{git}
# git clone git://git.freedesktop.org/git/xorg/xserver xgl
# git archive --format=tar --prefix=xgl-$(date +%Y%m%d)/ origin/xgl-0-0-1 | lzma > ../xgl-$(date +%Y%m%d).tar.lzma
%define release		%mkrel 0.%{git}.%{rel}
%define srcpath		%{shortname}-%{git}.tar.lzma
%define distname	%{shortname}-%{git}
%else
%define release		%mkrel %{rel}
%define distname	%{shortname}-%{version}
%define srcpath		%{distname}.tar.bz2
%endif

Name:		%{name}
Version:	%{version}
Release:	%{release}
Summary:	Xserver that uses OpenGL
License:	MIT
Group:		System/X11
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot
URL:		http://www.freedesktop.org/wiki/Software/Xgl
Source0:	%{srcpath}
Source1:	Xgl.defaults
Patch1:		0003-Use-a-X-wrapper-that-uses-pam-and-consolehelper-to-give-X-root-privileges.txt
Patch2:		0004-Blue-background-on-startup.txt
Patch3:		xgl-dpms_fix.patch
Patch4:		x11-server-xgl-cve-2007-1003.patch
Patch5:		xorg-git-CVE-2007-4730.patch
Patch6:		xgl-fix-mesa-includes.patch
# From master branch: AC_SUBST libdir, exec_prefix and prefix
# separately or else autoconf barfs - AdamW 2008/07
Patch7:		x11-server-xgl-20080722-autoconf.patch
# Fix build with glibc 2.8: solution suggested by various Gentoo
# patches for the same issue - AdamW 2008/07
Patch8:		x11-server-xgl-20080722-glibc28.patch

# Security fixes from stock x11-server - AdamW 2008/08
Patch100:	x11-server-1.1.1-rh-CVE-2008-1377.patch
Patch101:	x11-server-1.1.1-rh-CVE-2008-1379.patch
Patch102:	x11-server-1.1.1-rh-CVE-2008-2360.patch
Patch103:	x11-server-1.1.1-rh-CVE-2008-2361.patch
# Had to add a bit to this one to make it build - AdamW 2008/08
Patch104:	xgl-x11-server-1.1.1-rh-CVE-2008-2362.patch

BuildRequires:	libglitz-devel
BuildRequires:	libfontenc-devel
BuildRequires:	libxau-devel
BuildRequires:	libxaw-devel
BuildRequires:	libxdmcp-devel
BuildRequires:	libxext-devel
BuildRequires:	libxfont-devel
BuildRequires:	libxi-devel
BuildRequires:	libxkbfile-devel
BuildRequires:	libxau-devel
BuildRequires:	libxkbui-devel
BuildRequires:	libxmu-devel
BuildRequires:	libxpm-devel
BuildRequires:	libxrender-devel
BuildRequires:	libxres-devel
BuildRequires:	libxxf86misc-devel
BuildRequires:	libxxf86vm-devel
BuildRequires:	libxfont-devel
BuildRequires:	x11-proto-devel
BuildRequires:	x11-util-macros
BuildRequires:	x11-xtrans-devel
BuildRequires:	libxrandr-devel
BuildRequires:	libxinerama-devel
BuildRequires:	mesa-source
BuildRequires:	pam-devel
Requires:	mesa-demos
Requires:	x11-server-xorg
Requires:	compositing-server-common
Provides:	compositing-server
# because of fontpath.d support
Requires:	libxfont >= 1.2.8-2mdv

%description
Xgl is an Xserver that uses OpenGL for its drawing operations. Some
operations like antialiased font rendering is noticably faster with
this technology, and future graphics hardware might only have support
for 3D operations and no 2D core any more.

%prep
%setup -q -n %{distname}
%patch1  -p1 -b .xwrapper
%patch2 -p1 -b .blue_bg
%patch3 -p1 -b .dpms_fix
%patch4 -p0 -b .cve-2007-1003
%patch5 -p1 -b .cve-2007-4730
%patch6 -p1 -b .includes
%patch7 -p1 -b .autoconf
%patch8 -p1 -b .glibc28
%patch100 -p1
%patch101 -p1
%patch102 -p1
%patch103 -p1
%patch104 -p1

%build
autoreconf -v --install
%configure2_5x	--prefix=%{_prefix} \
		--libdir=%{_prefix}/%{_lib} \
		--enable-xgl \
		--disable-xorg \
		--disable-xprint \
		--enable-glx \
		--enable-dri \
		--with-default-font-path="catalogue:%{_sysconfdir}/X11/fontpath.d" \
		--with-mesa-source=/usr/src/Mesa/ \
		--disable-dmx \
		--disable-xvfb \
		--disable-xnest \
		--enable-xwrapper \
		--enable-pam \
		--enable-xglx
%make

%install
rm -rf %{buildroot}
%makeinstall_std

# use Xwrapper
install -d %{buildroot}%{_prefix}/%{_lib}/xorg/bin/
mv %{buildroot}%{_prefix}/bin/Xgl %{buildroot}%{_prefix}/%{_lib}/xorg/bin/Xgl
mv %{buildroot}%{_prefix}/bin/Xwrapper %{buildroot}%{_prefix}/%{_lib}/xorg/bin/Xgl-wrapper
ln -s ../%{_lib}/xorg/bin/Xgl-wrapper %{buildroot}%{_prefix}/bin/Xgl

# (blino) would conflict with x11-server-xorg
rm -f %{buildroot}%{_prefix}/share/man/man1/Xserver.1*
# (blino) would conflict with x11-server-devel
rm -f %{buildroot}%{_prefix}/%{_lib}/pkgconfig/xorg-server.pc
rm -f %{buildroot}%{_prefix}/share/aclocal/xorg-server.m4
# (blino) in x11-server-common
rm -f %{buildroot}%{_prefix}/%{_lib}/xserver/SecurityPolicy
rmdir %{buildroot}%{_prefix}/%{_lib}/xserver

install -D -m644 %{SOURCE1} %{buildroot}%{_datadir}/compositing-server/Xgl.defaults

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%{_prefix}/bin/Xgl*
%{_prefix}/%{_lib}/xorg/bin/Xgl
%attr(4755,root,root)%{_prefix}/%{_lib}/xorg/bin/Xgl-wrapper
%{_prefix}/%{_lib}/xorg/modules/%{shortname}
%{_prefix}/share/X11/xkb/compiled/README.compiled
%{_datadir}/compositing-server/Xgl.defaults




%changelog
* Wed Oct 01 2008 Adam Williamson <awilliamson@mandriva.com> 0.0.1-0.20080722.3mdv2009.0
+ Revision: 290396
- update 0004-Blue-background-on-startup.txt for new, improved shade of blue :)

* Thu Aug 21 2008 Adam Williamson <awilliamson@mandriva.com> 0.0.1-0.20080722.2mdv2009.0
+ Revision: 274475
- add five security fix patches from 2008.1 x11-server-xorg update branch:
  	+ CVE-2008-1377
  	+ CVE-2008-1379
  	+ CVE-2008-2360
  	+ CVE-2008-2361
  	+ CVE-2008-2362

* Wed Jul 23 2008 Adam Williamson <awilliamson@mandriva.com> 0.0.1-0.20080722.1mdv2009.0
+ Revision: 241748
- rebuild
- add glibc28.patch to fix build with glibc 2.8, based on similar patches in
  Gentoo
- add autoconf.patch from master branch to fix problem in configure.ac
- drop snapshot location as it's 404: add instructions to pull snapshot direct
  from git
- disable underlinking protection (breaks build and not needed)
- correct license (MIT not GPL)
- clean spec:
  	+ drop conditionals for 2006 and earlier
  	+ reorder patches
  	+ modern variable names
- new git snapshot 20080722

  + Oden Eriksson <oeriksson@mandriva.com>
    - rebuild

  + Thierry Vignaud <tvignaud@mandriva.com>
    - fix no-buildroot-tag
    - kill re-definition of %%buildroot on Pixel's request

* Wed Oct 03 2007 Gustavo Pichorim Boiko <boiko@mandriva.com> 0.0.1-0.20070917.2mdv2008.0
+ Revision: 95225
- Fix the RandR version reported by Xgl: it does not suport RandR 1.2, only 1.1

* Mon Sep 17 2007 Ademar de Souza Reis Jr <ademar@mandriva.com.br> 0.0.1-0.20070917.1mdv2008.0
+ Revision: 89295
- security fix: CVE-2007-4730.patch
- new git snapshot: 2007-09-17 (the previous one was
  incompatible with our current mesa - compilation was broken)
- fix default font-path (was still pointing to xfs, which is now
  disabled by default)
- add xgl-fix-mesa-includes.path, a small include fix

* Thu May 03 2007 Ademar de Souza Reis Jr <ademar@mandriva.com.br> 0.0.1-0.20070105.6mdv2008.0
+ Revision: 22012
- applying fix for CVE-2007-1003 (patch copied from 2007.1
  update package)


* Sat Apr 07 2007 Olivier Blin <oblin@mandriva.com> 0.0.1-0.20070105.5mdv2007.1
+ Revision: 150915
- borrow Xwrapper from the Xorg package to run Xgl as root (and thus allow it to take over lock files, #24923, #27104)

* Mon Mar 19 2007 Gustavo Pichorim Boiko <boiko@mandriva.com> 0.0.1-0.20070105.4mdv2007.1
+ Revision: 146795
- Really disable DPMS in the underlying X server (not only when Xgl starts Xorg
  by itself) (#28873).

* Wed Mar 14 2007 Olivier Blin <oblin@mandriva.com> 0.0.1-0.20070105.3mdv2007.1
+ Revision: 143564
- use configure rpm macro to fix datadir (and thus xkb...)

* Fri Mar 02 2007 Gustavo Pichorim Boiko <boiko@mandriva.com> 0.0.1-0.20070105.2mdv2007.1
+ Revision: 131571
- update the blue bg patch to fix an error of not properly telling X we have a
  bg color, and not a bg tile pixmap

* Tue Feb 13 2007 Olivier Blin <oblin@mandriva.com> 0.0.1-0.20070105.1mdv2007.1
+ Revision: 120640
- update snapshot (20070105) for new Mesa (and drop merged patches)
- rename COMPOSITING_SERVER_OPTIONS as COMPOSITING_SERVER_ARGS
- remove unused variable
- move Xgl xinit.d and sysconfig files in compositing-server-common
- do not try to resolve names

* Fri Sep 15 2006 Olivier Blin <oblin@mandriva.com> 0.0.1-0.20060714.9mdv2007.0
+ Revision: 61372
- don't use -ac option but add cookies for Xgl display instead (#24730)

* Fri Sep 08 2006 Olivier Blin <oblin@mandriva.com> 0.0.1-0.20060714.8mdv2007.0
+ Revision: 60559
- remove LD_LIBRARY_PATH hack, only compiz requires it
- fix man page removal (section is not 1x anymore but 1)
- really disable Xgl in failsafe/drak3d sessions

  + Pixel <pixel@mandriva.com>
    - adapt background color (as requested by our graphic team)

* Sat Aug 26 2006 Olivier Blin <oblin@mandriva.com> 0.0.1-0.20060714.6mdv2007.0
+ Revision: 58047
- fix typo in xinit.d script __LIBDIR__ replacement

* Fri Aug 25 2006 Olivier Blin <oblin@mandriva.com> 0.0.1-0.20060714.5mdv2007.0
+ Revision: 57974
- increase release
- remove hardcoded Xgl path
- don't start compiz if in failsafe or drak3d session
- remove extra underscore in xinit script name
- do not enable Xgl by default
- add blue background patch from x11-server

* Wed Aug 23 2006 Olivier Blin <oblin@mandriva.com> 0.0.1-0.20060714.4mdv2007.0
+ Revision: 57449
- x11-server-xgl-0.0.1-0.20060714.4mdv2007.0
- add missing buildrequires, so that the xglx module gets always built (Christiaan Welvaart)

* Tue Aug 22 2006 Olivier Blin <oblin@mandriva.com> 0.0.1-0.20060714.3mdv2007.0
+ Revision: 56920
- x11-server-xgl-0.0.1-0.20060714.3mdv2007.0
- handle the no3ddesktop cmdline option
- allow to configure Xgl options
- allow to configure Xgl display
- add XkbGetKeyboard (needed for gnome keyboard tool)
- enable xkb
- don't start Xgl when both client and server GLX_EXT_tfp are present, not only server (fglrx fix)

* Sat Aug 19 2006 Olivier Blin <oblin@mandriva.com> 0.0.1-0.20060714.2mdv2007.0
+ Revision: 56752
- x11-server-xgl-0.0.1-0.20060714.2mdv2007.0
- auto-start Xgl if possible and useful

* Thu Aug 17 2006 Olivier Blin <oblin@mandriva.com> 0.0.1-0.20060714.1mdv2007.0
+ Revision: 56492
- mark the sysconfig file as config
- add url
- fix summary ended with dot
- add xgl-arrayobj.patch
- really use unix/:-1 as default font path
- export LD_LIBRARY_PATH
- remove unpackaged xserver directory
- really remove xorg-server.m4
- 64 bit fixes (Colin Guthrie)
- fix build with cooker's Mesa
- don't package xorg-server.m4
- use git snapshot
- add Xinerama support (Colin Guthrie)
- use unix/:-1 as default fontpath (Colin Guthrie)
- add buildrequires (Colin Guthrie)
- use xgl as shortname (Colin Guthrie)
- require x11-server-xorg (Christiaan Welvaart)
- add some missing buildroot
- SecurityPolicy is in x11-server-common (Christiaan Welvaart)
- don't package pkgconfig file (Christiaan Welvaart)
- don't package Xserver man page (Christiaan Welvaart)
- rename xgl as x11-server-xgl (Christiaan Welvaart)
- require mesa-demos (#24335)

* Fri Aug 11 2006 Olivier Blin <oblin@mandriva.com> 0.0.1-0.20060808.1mdv2007.0
+ Revision: 55443
- really add xgl session files
- allow to run XGL from X session (config in /etc/sysconfig/xgl)
- fix typo
- fix man page in files list
- fix typo
- use make macro and clean buildroot
- xgl-0.0.1-20060808
- remove 2006.0 hacks
- remove 2006.0 hacks
- don't use prefix on cooker
- pass xgldir as prefix to configure script
- revert "Mesa CVS head" specific patches to build with cooker Mesa
- cooker updates (from Vincent Guardiola)
- import xgl-0.0.1-1mdv2007.0

